lava_results_app/urls.py
# -*- coding: utf-8 -*-
# Copyright (C) 2015-2018 Linaro Limited
#
# Author: Neil Williams <neil.williams@linaro.org>
#         Stevan Radakovic <stevan.radakovic@linaro.org>
#
# This file is part of LAVA.
#
# LAVA is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License version 3
# as published by the Free Software Foundation
#
# LAVA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with LAVA.  If not, see <http://www.gnu.org/licenses/>.

"""
URL mappings for the LAVA Results application
"""
from django.conf.urls import url
from lava_results_app.views import (
    add_bug_link,
    delete_bug_link,
    get_bug_links_json,
    index,
    metadata_export,
    suite,
    suite_csv_stream,
    suite_csv,
    suite_yaml,
    suite_testcase_count,
    testcase,
    testcase_yaml,
    testjob,
    testjob_csv,
    testjob_yaml,
    testjob_yaml_summary,
    testset,
)
from lava_results_app.views.query.views import (
    get_query_group_names,
    get_query_names,
    query_list,
    query_add,
    query_add_condition,
    query_add_group,
    query_copy,
    query_custom,
    query_delete,
    query_detail,
    query_display,
    query_edit,
    query_edit_condition,
    query_export,
    query_export_custom,
    query_group_list,
    query_refresh,
    query_remove_condition,
    query_omit_result,
    query_include_result,
    query_select_group,
    query_toggle_published,
)
from lava_results_app.views.chart.views import (
    get_chart_group_names,
    chart_list,
    chart_add,
    chart_add_group,
    chart_custom,
    chart_delete,
    chart_detail,
    chart_display,
    chart_edit,
    chart_group_list,
    chart_select_group,
    chart_toggle_published,
    chart_query_add,
    chart_query_edit,
    chart_query_remove,
    chart_query_order_update,
    chart_omit_result,
    settings_update,
)

urlpatterns = [
    url(r"^$", index, name="lava_results"),
    url(r"^query$", query_list, name="lava.results.query_list"),
    url(r"^query/\+add$", query_add, name="lava.results.query_add"),
    url(r"^query/\+custom$", query_custom, name="lava.results.query_custom"),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)$",
        query_display,
        name="lava.results.query_display",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+detail$",
        query_detail,
        name="lava.results.query_detail",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+edit$",
        query_edit,
        name="lava.results.query_edit",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+delete$",
        query_delete,
        name="lava.results.query_delete",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+export$",
        query_export,
        name="lava.results.query_export",
    ),
    url(
        r"^query/\+export-custom$",
        query_export_custom,
        name="lava.results.query_export_custom",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+toggle-published$",
        query_toggle_published,
        name="lava.results.query_toggle_published",
    ),
    url(r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+copy$", query_copy),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+refresh$",
        query_refresh,
        name="lava.results.query_refresh",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+add-condition$",
        query_add_condition,
        name="lava.results.query_add_condition",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/(?P<id>\d+)/\+remove-condition$",
        query_remove_condition,
        name="lava.results.query_remove_condition",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/(?P<id>\d+)/\+edit-condition$",
        query_edit_condition,
        name="lava.results.query_edit_condition",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+add-group$",
        query_add_group,
        name="query_add_group",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/\+select-group$",
        query_select_group,
        name="query_select_group",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/(?P<id>\d+)/\+omit-result$",
        query_omit_result,
        name="lava.results.query_omit_result",
    ),
    url(
        r"^query/~(?P<username>[^/]+)/(?P<name>[a-zA-Z0-9-_]+)/(?P<id>\d+)/\+include-result$",
        query_include_result,
        name="lava.results.query_include_result",
    ),
    url(r"^query/get-query-groups$", query_group_list, name="query_group_list"),
    url(
        r"^query/\+get-group-names$",
        get_query_group_names,
        name="get_query_group_names",
    ),
    url(
        r"^query/\+get-query-names$",
        get_query_names,
        name="lava.results.get_query_names",
    ),
    url(r"^(?P<job>[0-9]+|[0-9]+\.[0-9]+)$", testjob, name="lava.results.testjob"),
    url(
        r"^(?P<job>[0-9]+|[0-9]+\.[0-9]+)/csv$",
        testjob_csv,
        name="lava.results.testjob_csv",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+\.[0-9]+)/yaml$",
        testjob_yaml,
        name="lava.results.testjob_yaml",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+\.[0-9]+)/yaml_summary$",
        testjob_yaml_summary,
        name="lava.results.testjob_yaml_summary",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+\.[0-9]+)/metadata$",
        metadata_export,
        name="lava.results.job.metadata",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+\.[0-9]+)/(?P<pk>[-_a-zA-Z0-9.]+)$",
        suite,
        name="lava.results.suite",
    ),
    url(r"^chart$", chart_list, name="lava.results.chart_list"),
    url(r"^chart/\+add$", chart_add, name="lava.results.chart_add"),
    url(r"^chart/\+custom$", chart_custom, name="lava.results.chart_custom"),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)$",
        chart_display,
        name="lava.results.chart_display",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/\+detail$",
        chart_detail,
        name="lava.results.chart_detail",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/\+edit$",
        chart_edit,
        name="lava.results.chart_edit",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/\+delete$",
        chart_delete,
        name="lava.results.chart_delete",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/\+toggle-published$",
        chart_toggle_published,
        name="lava.results.chart_toggle_published",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/\+chart-query-add$",
        chart_query_add,
        name="lava.results.chart_query_add",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/(?P<id>\d+)/\+chart-query-remove$",
        chart_query_remove,
        name="lava.results.chart_query_remove",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/(?P<id>\d+)/\+chart-query-edit$",
        chart_query_edit,
        name="lava.results.chart_query_edit",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/\+add-group$",
        chart_add_group,
        name="chart_add_group",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/\+select-group$",
        chart_select_group,
        name="chart_select_group",
    ),
    url(r"^chart/\+get-chart-groups$", chart_group_list, name="chart_group_list"),
    url(
        r"^chart/\+get-group-names$",
        get_chart_group_names,
        name="get_chart_group_names",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/(?P<id>\d+)/\+settings-update$",
        settings_update,
        name="chart_settings_update",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/\+chart-query-order-update$",
        chart_query_order_update,
        name="chart_query_order_update",
    ),
    url(
        r"^chart/(?P<name>[a-zA-Z0-9-_]+)/(?P<id>\d+)/(?P<result_id>\d+)/\+omit-result$",
        chart_omit_result,
        name="lava.results.chart_omit_result",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+\.[0-9]+)/(?P<pk>[-_a-zA-Z0-9.]+)/(?P<ts>[-_a-zA-Z0-9.]+)/(?P<case>[-_a-zA-Z0-9.+]+)$",
        testset,
        name="lava.results.testset",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+\.[0-9]+)/(?P<pk>[-_a-zA-Z0-9.]+)/csv$",
        suite_csv,
        name="lava.results.suite_csv",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+.[0-9]+)/(?P<pk>[-_a-zA-Z0-9.]+)/stream/csv$",
        suite_csv_stream,
        name="lava.results.suite_csv_stream",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+.[0-9]+)/(?P<pk>[-_a-zA-Z0-9.]+)/yaml$",
        suite_yaml,
        name="lava.results.suite_yaml",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+.[0-9]+)/(?P<pk>[-_a-zA-Z0-9.]+)/\+testcase-count$",
        suite_testcase_count,
        name="lava.results.suite_testcase_count",
    ),
    url(r"^testcase/(?P<case_id>[0-9]+)$", testcase, name="lava.results.testcase"),
    url(
        r"^(?P<job>[0-9]+|[0-9]+.[0-9]+)/(?P<pk>[-_a-zA-Z0-9.]+)/(?P<case_id>[0-9]+)$",
        testcase,
        name="lava.results.testcase",
    ),
    url(
        r"^(?P<job>[0-9]+|[0-9]+.[0-9]+)/(?P<pk>[-_a-zA-Z0-9.]+)/(?P<case_id>[-_a-zA-Z0-9.\(\)+]+)$",
        testcase,
        name="lava.results.testcase",
    ),
    url(
        r"^testcase/(?P<pk>[0-9]+)/yaml$",
        testcase_yaml,
        name="lava.results.testcase_yaml",
    ),
    url(
        r"^get-bug-links-json$",
        get_bug_links_json,
        name="lava.results.get_bug_links_json",
    ),

lava_results_app/views/chart/forms.py
# -*- coding: utf-8 -*-
# Copyright (C) 2015-2018 Linaro Limited
#
# Author: Stevan Radakovic <stevan.radakovic@linaro.org>
#
# This file is part of LAVA.
#
# LAVA is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License version 3
# as published by the Free Software Foundation
#
# LAVA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with LAVA.  If not, see <http://www.gnu.org/licenses/>.

from django import forms
from lava_results_app.models import Chart, ChartQuery, ChartQueryUser, TestCase


class ChartForm(forms.ModelForm):
    class Meta:
        model = Chart
        exclude = ("is_published", "chart_group", "group", "queries")
        widgets = {"owner": forms.HiddenInput}

    def __init__(self, owner, *args, **kwargs):
        super().__init__(*args, **kwargs)

    def save(self, commit=True, **kwargs):
        instance = super().save(commit=commit, **kwargs)
        return instance


class ChartQueryForm(forms.ModelForm):
    class Meta:
        model = ChartQuery
        exclude = ()
        widgets = {
            "chart": forms.HiddenInput,
            "query": forms.HiddenInput,
            "relative_index": forms.HiddenInput,
        }

    def __init__(self, user, *args, **kwargs):
        super().__init__(*args, **kwargs)

    def save(self, commit=True, **kwargs):
        instance = super().save(commit=commit, **kwargs)
        return instance

    def clean(self):
        form_data = self.cleaned_data

        try:
            # Chart type validation.
            if (
                form_data["query"].content_type.model_class() == TestCase
                and form_data["chart_type"] == "pass/fail"
            ):
                self.add_error(
                    "chart_type",
                    "Pass/fail is incorrect value for 'chart_type' with TestCase based queries.",
                )

        except KeyError:
            # form_data will pick up the rest of validation errors.
            pass

        return form_data


class ChartQueryUserForm(forms.ModelForm):
    class Meta:
        model = ChartQueryUser
        exclude = ["user", "chart_query"]

    def __init__(self, user, *args, **kwargs):
        super().__init__(*args, **kwargs)

lava_results_app/views/query/forms.py
# -*- coding: utf-8 -*-
# Copyright (C) 2015-2018 Linaro Limited
#
# Author: Stevan Radakovic <stevan.radakovic@linaro.org>
#
# This file is part of LAVA.
#
# LAVA is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License version 3
# as published by the Free Software Foundation
#
# LAVA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with LAVA.  If not, see <http://www.gnu.org/licenses/>.

import contextlib
import datetime
import simplejson

from django import forms
from django.conf import settings
from django.db import models
from django.utils.html import escape

from lava_results_app.models import Query, QueryCondition


class QueryForm(forms.ModelForm):
    class Meta:
        model = Query
        exclude = (
            "is_published",
            "query_group",
            "group",
            "is_changed",
            "last_updated",
            "is_updating",
        )
        widgets = {"owner": forms.HiddenInput}

    def __init__(self, owner, *args, **kwargs):
        is_copy = kwargs.pop("is_copy", None)
        super().__init__(*args, **kwargs)
        if is_copy:
            from copy import deepcopy

            self.instance = deepcopy(self.instance)
            self.instance.id = None
            self.instance.pk = None

    def save(self, commit=True, **kwargs):
        instance = super().save(commit=commit, **kwargs)
        return instance

    def clean(self):
        form_data = self.cleaned_data

        with contextlib.suppress(KeyError, Query.DoesNotExist):
            # Existing (or archived) Query validataion.
            existing_query = Query.objects.get(
                name=form_data["name"], owner=form_data["owner"]
            )
            if existing_query:
                if existing_query.is_archived:
                    self.add_error(
                        "name",
                        """ Query already exists but is archived. Please
                        contact system adminstrator or consult LAVA doc. """,
                    )
                elif not self.instance.id:
                    self.add_error(
                        "name", "Query with this owner and name already exists."
                    )

        return form_data


class QueryConditionForm(forms.ModelForm):
    class Meta:
        model = QueryCondition
        fields = ("table", "query", "field", "operator", "value")
        widgets = {"query": forms.HiddenInput}

    condition_choices = forms.CharField(widget=forms.HiddenInput)

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        if "query" in self.initial and self.initial["query"].__class__ == Query:
            condition_choices = QueryCondition.get_condition_choices()

            self.fields["condition_choices"].initial = simplejson.dumps(
                condition_choices
            )

    def save(self, commit=True, **kwargs):
        return super().save(commit=commit, **kwargs)

    def clean(self):
        form_data = self.cleaned_data

        try:
            # Field validation.
            field_choices = QueryCondition.FIELD_CHOICES[
                form_data["table"].model_class()
            ]
            if field_choices:
                if form_data["field"] not in field_choices:
                    self.add_error(
                        "field",
                        "Valid choices for 'field' are: %s"
                        % (", ".join(field_choices)),
                    )

                # Choices validation
                field_object = (
                    form_data["table"].model_class()._meta.get_field(form_data["field"])
                )
                choices = field_object.choices
                if choices and form_data["value"] not in dict(choices).values():
                    self.add_error(
                        "value",
                        "Valid choices for 'value' are: %s"
                        % (", ".join(dict(choices).values())),
                    )

                if isinstance(field_object, models.DateTimeField):
                    try:
                        datetime.datetime.strptime(
                            form_data["value"], settings.DATETIME_INPUT_FORMATS[0]
                        )
                    except ValueError:
                        self.add_error(
                            "value",
                            "Incorrect format for 'value', try: %s"
                            % settings.DATETIME_INPUT_FORMATS[0],
                        )
        except KeyError:
            # form_data will pick up the rest of validation errors.
            pass

        return form_data

    def clean_value(self):
        value = escape(self.cleaned_data["value"])
        return value

lava_results_app/templates/lava_results_app/chart_form.html
{% extends "layouts/content.html" %}

{% block styles %}
<link rel="stylesheet" type="text/css" href="{{ STATIC_URL }}lava_results_app/css/chart.css"/>
{% endblock %}

{% block content %}
{% if form.instance.id %}
<h1>Edit chart &ldquo;{{ form.instance.name }}&rdquo;…</h1>
{% else %}
<h1>Add new chart…</h1>
{% endif %}

{% block content_form %}
<form action="" method="post">{% csrf_token %}

  {% if form.errors %}
  <div class="errors">
    <div>
      {{ form.non_field_errors }}
      <ul>
	{% for field in form %}
	{% if field.errors %}
        <li>{{ field.label }}: {{ field.errors|striptags }}</li>
        {% endif %}
	{% endfor %}
      </ul>
    </div>
  </div>
  {% endif %}

<div class="form-field">
  {{ form.name.label_tag }}
  {{ form.name }}
  {{ form.owner }}
</div>
<div class="form-field">
  {{ form.description.label_tag }}
  {{ form.description }}
</div>

<div class="submit-button">
  <input type="submit" value="Save" />
</div>
</form>

{% endblock content_form %}

{% endblock %}

lava_results_app/templates/lava_results_app/job.html
{% extends "layouts/content.html" %}
{% load i18n %}
{% load utils %}
{% load django_tables2 %}

{% block content %}
    <h2>LAVA Results for {{ job_link }}
    {% if not failed_definitions %}
      <span
          class="label {% if job.health == job.HEALTH_COMPLETE %}label-success{% else %}label-warning{% endif %}"
          {% if job.health == job.HEALTH_COMPLETE %}title="All submitted definitions have started execution."{% endif %}>{{ job.get_state_display }}
      </span>
    {% endif %}
    </h2>

    {% if failed_definitions %}
        <div class="alert alert-warning alert-dismissable">
        <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
        <p><b>Warning</b>: some submitted test definitions did not start execution.</p>
        <ul>
            {% for item in failed_definitions %}
            <li><dl class="dl-horizontal">
                {% for key, value in item.items %}
                    <dt>{{ key }}</dt>
                    <dd>{{ value }}</dd>
                {% endfor %}
            </dl></li>
            {% endfor %}
        </ul>
        </div>
    {% endif %}

<div class="row">
  <div class="col-md-4">
    <h4 class="modal-header">Exports
        </h4>
    <dl class="dl-horizontal">
      <dt>Test results summary :</dt>
      <dd><a class="btn btn-xs btn-info" href="{% url 'lava.results.testjob_yaml_summary' job.id %}"
         title="Download test job summary as YAML"><span class="glyphicon glyphicon-download"></span> YAML</a></dd>
      <dt>Test results :</dt>
      <dd><a class="btn btn-xs btn-info" href="{% url 'lava.results.testjob_csv' job.id %}"
         title="Download results as CSV"><span class="glyphicon glyphicon-download"></span> CSV</a> or <a
              class="btn btn-xs btn-info" href="{% url 'lava.results.testjob_yaml' job.id %}"
         title="Download results as YAML"><span class="glyphicon glyphicon-download"></span> YAML</a></dd>
      <dt>Job metadata :</dt>
      <dd><a class="btn btn-xs btn-info" href="{% url 'lava.results.job.metadata' job.id %}"
         title="Download metadata as YAML"><span class="glyphicon glyphicon-download"></span> YAML</a></dd>
    </dl>
  </div>
  <div class="col-md-4">
    <h4 class="modal-header">Actions</h4>
    <a href="#" data-toggle="modal" data-target="#similar_jobs_modal" class="btn btn-primary">Similar jobs</a>
  </div>
  <div class="col-md-4">
    <h4 class="modal-header">Details</h4>
    {% if job.actual_device %}
    <dl class="dl-horizontal">
        <dt>Device :</dt>
        <dd><a href="{{ job.actual_device.get_absolute_url }}">{{ job.actual_device.hostname }}</a></dd>
    {% endif %}
{% if job.is_multinode %}
    <dl class="dl-horizontal">
{% for role in job.sub_jobs_list %}
  {% if role.id != job.id %}
     <dt>{{ role.device_role }} role:</dt>
     <dd><a href="{{ role.results_link }}">{{ role.sub_id }}</a> ({{ role.id }})</dd>
  {% else %}
     <dt>{{ role.device_role }} role:</dt>
     <dd>{{ role.sub_id }} ({{ role.id }})</dd>
  {% endif %}
{% endfor %}
{% endif %}
    </dl>
  </div>
</div>
    {% render_table suite_table %}
<div class="panel-group" id="results_accordion">
  <div class="panel panel-default">
    <div class="panel-heading">
      <h4><a data-toggle="collapse" data-parent="#results_accordion" href="#metadata_collapse">
        Metadata
      </a>
      </h4>
    </div>
  {% spaceless %}
    <div id="metadata_collapse" class="panel-collapse collapse">
      <div class="panel-body">
      <p>The <b>key</b> is the name of the metadata named attribute which can be used in query conditions.
          Values relating to devices, device-types and URLs are formatted as links. Due to
          the variation between different git server interfaces, it is not possible to construct
          a full URL to the test definition file. The commit id of the test definition is part of
          the <i>lava</i> results for the job.
      </p>
      <p>Inline test definitions which do not call <code>lava-test-case</code> will not record any
      results and are shown in the metadata with the <code>omitted</code> prefix.</p>
      <p>Attributes relating to items which can repeat within a single job include a number representing
          the sequence of that item within the job. For example, <i>boot.0.method</i> is the name of an
          attribute containing information on the first boot method used in the job. <i>boot.0.commands</i>
          would be an attribute containing information on the commands used by the first boot method in
          the job.
      </p>
      <p>Metadata submitted as part of the job submission is also included, if present.</p>
       <div class="row">
       <div class="col-xs-12">
        <ul>
          {% for key, value in metadata.items %}
              {% if 'target' in key %}
                  <li><b>{{ key }}</b>:
                  {{ key|markup_metadata:value }}</li>
              {% elif 'deploy' in key %}
                  <li><b>{{ key }}</b>:
                  {{ value }}</li>
              {% elif 'omit.' in key %}
                  <!-- inline without test cases -->
              {% elif 'boot' in key %}
                  <li><b>{{ key }}</b>:
                  {{ value }}</li>
              {% elif 'test' in key %}
                  <li><b>{{ key }}</b>:
                  {{ key|markup_metadata:value }}</li>
              {% elif 'parameters' in key %}
                  <li><b>{{ key }}</b>:
                  <ul>{% for paramkey, paramvalue in value.items %}
                      <li>{{ paramkey }}: {{ paramvalue }}</li>
                      {% endfor %}
                  </ul></li>
              {% else %}
                  <li><b>{{ key }}</b>:
                  {{ value }}</li>
              {% endif %}
          {% endfor %}
        </ul>
        </div>
        </div>
      </div>
    </div>
  {% endspaceless %}
  </div>
 </div>

<div class="panel-group" id="notifications_accordion">
  <div class="panel panel-default">
    <div class="panel-heading">
      <h4><a data-toggle="collapse" data-parent="#notifications_accordion" href="#notification_collapse">
        Notifications
      </a>
      </h4>
    </div>
  {% spaceless %}
    <div id="notification_collapse" class="panel-collapse collapse">
      <div class="panel-body">
        <dl class="dl-horizontal">
          {% for recipient in job.notification.notificationrecipient_set.all %}
          <dt>Recipient</dt>
          {% if recipient.method == 1 %}
          <dd>{{ recipient.irc_handle_name }} on {{ recipient.irc_server_name }}</dd>
          {% else %}
          <dd>{{ recipient.email_address }}</dd>
          {% endif %}
          <dt>Method</dt>
          <dd>{{ recipient.get_method_display }}</dd>
          <dt>Status</dt>
          <dd>{{ recipient.get_status_display }}</dd>
          <br/>
          {% empty %}
          No notifications for this job.
          {% endfor %}
        </dl>
      </div>
    </div>
  {% endspaceless %}
  </div>
</div>

{% include "_similar_jobs.html" %}
{% include "_bug_links.html" %}

{% endblock %}
{% block scripts %}
<script type="text/javascript">
  var condition_choices = JSON.parse($("#id_condition_choices").val());
  var content_types = JSON.parse($("#id_available_content_types").val());
  var bug_links_url = "{% url 'lava.results.get_bug_links_json' %}";
  var delete_bug_url = "{% url 'lava.results.delete_bug_link' %}";
  var csrf_token = '{{csrf_token}}';
</script>
<script type="text/javascript" src="{{ STATIC_URL }}lava_scheduler_app/js/tables.min.js"></script>
<script type="text/javascript" src="{{ STATIC_URL }}lava_scheduler_app/js/similar-jobs.min.js"></script>
<script type="text/javascript" src="{{ STATIC_URL }}lava_results_app/js/bug-links.min.js"></script>
{% endblock %}

lava_results_app/templates/lava_results_app/suite_actions_field.html
<div class="text-nowrap">
  <a href="{{ record.get_absolute_url }}" class="btn btn-xs btn-primary" title="View test suite">
    <span class="glyphicon glyphicon-eye-open"></span>
  </a>
  <a href="{{ record.job.get_absolute_url }}" class="btn btn-xs btn-info" title="View job details">
    <span class="glyphicon glyphicon-chevron-left"></span>
  </a>
</div>